StandardOperation (Java SE 26 & JDK 26)
Description: declaration: module: jdk.dynalink, package: jdk.dynalink, enum: StandardOperation
Keywords: jdk.dynalink.StandardOperation class

# Enum Class StandardOperation

java.lang.Object
java.lang.Enum<StandardOperation>
jdk.dynalink.StandardOperation

All Implemented Interfaces:
  `Serializable, Comparable<StandardOperation>, Constable, Operation`

public enum StandardOperation extends Enum<StandardOperation> implements Operation
Defines the standard dynamic operations. The operations `GET` and `SET` must be used as part of a `NamespaceOperation`. `NamedOperation` can then be further used on these `NamespaceOperation`s to bind the name parameter of `GET` and `SET` operations, in which case it disappears from their type signature. `NamedOperation` can also be used to decorate `CALL` and `NEW` operations with a diagnostic name, and as such it does not affect their type signature.

Since:
  9

- ## Nested Class Summary

  ### Nested classes/interfaces declared in class Enum

  `Enum.EnumDesc<E>`
  Modifier and Type
  Class
  Description
  `static final class`
  `Enum.EnumDesc<E extends Enum<E>>`
  A nominal descriptor for an `enum` constant.

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `CALL`
  Call a callable object.
  `GET`
  Get the value from a namespace defined on an object.
  `NEW`
  Call a constructor object.
  `REMOVE`
  Removes the value from a namespace defined on an object.
  `SET`
  Set the value in a namespace defined on an object.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static StandardOperation`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static StandardOperation[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods declared in class Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`
  Modifier and Type
  Method
  Description
  `protected final Object`
  `clone()`
  Throws CloneNotSupportedException.
  `final int`
  `compareTo(StandardOperation o)`
  Compares this enum with the specified object for order.
  `final Optional<Enum.EnumDesc<StandardOperation>>`
  `describeConstable()`
  Returns an enum descriptor `EnumDesc` for this instance, if one can be constructed, or an empty `Optional` if one cannot be.
  `final boolean`
  `equals(Object other)`
  Returns true if the specified object is equal to this enum constant.
  `protected final void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization has been deprecated for removal.
  `final Class<StandardOperation>`
  `getDeclaringClass()`
  Returns the Class object corresponding to this enum constant's enum type.
  `final int`
  `hashCode()`
  Returns a hash code for this enum constant.
  `final String`
  `name()`
  Returns the name of this enum constant, exactly as declared in its enum declaration.
  `final int`
  `ordinal()`
  Returns the ordinal of this enumeration constant (its position in its enum declaration, where the initial constant is assigned an ordinal of zero).
  `String`
  `toString()`
  Returns the name of this enum constant, as contained in the declaration.
  `static <T extends Enum<T>>
  T`
  `valueOf(Class<T> enumClass, String name)`
  Returns the enum constant of the specified enum class with the specified name.

  ### Methods declared in class Object

  `getClass, notify, notifyAll, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

  ### Methods declared in interface Operation

  `named, withNamespace, withNamespaces`
  Modifier and Type
  Method
  Description
  `default NamedOperation`
  `named(Object name)`
  Returns a `NamedOperation` using this operation as its base.
  `default NamespaceOperation`
  `withNamespace(Namespace namespace)`
  Returns a `NamespaceOperation` using this operation as its base.
  `default NamespaceOperation`
  `withNamespaces(Namespace... namespaces)`
  Returns a `NamespaceOperation` using this operation as its base.

- ## Enum Constant Details

  - ### GET

    public static final StandardOperation GET
    Get the value from a namespace defined on an object. Call sites with this operation should have a signature of `(receiver, name)→value` or `(receiver)→value` when used with `NamedOperation`, with all parameters and return type being of any type (either primitive or reference). This operation must always be used as part of a `NamespaceOperation`.

  - ### SET

    public static final StandardOperation SET
    Set the value in a namespace defined on an object. Call sites with this operation should have a signature of `(receiver, name, value)→void` or `(receiver, value)→void` when used with `NamedOperation`, with all parameters and return type being of any type (either primitive or reference). This operation must always be used as part of a `NamespaceOperation`.

  - ### REMOVE

    public static final StandardOperation REMOVE
    Removes the value from a namespace defined on an object. Call sites with this operation should have a signature of `(receiver, name)→void` or `(receiver)→void` when used with `NamedOperation`, with all parameters being of any type (either primitive or reference). This operation must always be used as part of a `NamespaceOperation`.
    Since:
      10

  - ### CALL

    public static final StandardOperation CALL
    Call a callable object. Call sites with this operation should have a signature of `(callable, receiver, arguments...)→value`, with all parameters and return type being of any type (either primitive or reference). Typically, the callables are presumed to be methods of an object, so an explicit receiver value is always passed to the callable before the arguments. If a callable has no concept of a receiver, it is free to ignore the value of the receiver argument. The `CALL` operation is allowed to be used with a `NamedOperation` even though it does not take a name. Using it with a named operation won't affect its signature; the name is solely meant to be used as a diagnostic description for error messages.

  - ### NEW

    public static final StandardOperation NEW
    Call a constructor object. Call sites with this operation should have a signature of `(constructor, arguments...)→value`, with all parameters and return type being of any type (either primitive or reference). The `NEW` operation is allowed to be used with a `NamedOperation` even though it does not take a name. Using it with a named operation won't affect its signature; the name is solely meant to be used as a diagnostic description for error messages.

- ## Method Details

  - ### values

    public static StandardOperation[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static StandardOperation valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null